CodeForces 438D

At the children’s day, the child came to Picks’s house, and messed his house up. Picks was angry at him. A lot of important things were lost, in particular the favorite sequence of Picks.

Fortunately, Picks remembers how to repair the sequence. Initially he should create an integer array a[1], a[2], …, a[n]. Then he should perform a sequence of m operations. An operation can be one of the following:

Print operation l, r. Picks should write down the value of l-r sum.
Modulo operation l, r, x. Picks should perform assignment a[i] = a[i] mod x for each i (l ≤ i ≤ r).
Set operation k, x. Picks should set the value of a[k] to x (in other words perform an assignment a[k] = x).
Can you help Picks to perform the whole sequence of operations?

Input
The first line of input contains two integer: n, m (1 ≤ n, m ≤ 105). The second line contains n integers, separated by space: a[1], a[2], …, a[n] (1 ≤ a[i] ≤ 109) — initial value of array elements.

Each of the next m lines begins with a number type .

If type = 1, there will be two integers more in the line: l, r (1 ≤ l ≤ r ≤ n), which correspond the operation 1.
If type = 2, there will be three integers more in the line: l, r, x (1 ≤ l ≤ r ≤ n; 1 ≤ x ≤ 109), which correspond the operation 2.
If type = 3, there will be two integers more in the line: k, x (1 ≤ k ≤ n; 1 ≤ x ≤ 109), which correspond the operation 3.
Output
For each operation 1, please print a line containing the answer. Notice that the answer may exceed the 32-bit integer.

Examples Input

5 5
1 2 3 4 5
2 3 5 4
3 3 5
1 2 5
2 1 3 3
1 1 3

Output

8
5

Input

10 10
6 9 6 7 6 1 10 10 9 5
1 3 9
2 7 10 9
2 5 10 8
1 4 7
3 3 7
2 7 9 9
1 2 4
1 6 6
1 5 9
3 1 10

Output

49
15
23
1
9

Note

Consider the first testcase:

At first, a = {1, 2, 3, 4, 5}.
After operation 1, a = {1, 2, 3, 0, 1}.
After operation 2, a = {1, 2, 5, 0, 1}.
At operation 3, 2 + 5 + 0 + 1 = 8.
After operation 4, a = {1, 2, 2, 0, 1}.
At operation 5, 1 + 2 + 2 = 5.

在儿童节那天,孩子来到匹克的家,把他的房子搞砸了。皮克斯对他生气。很多重要的事情都丢失了,特别是最喜欢的Picks序列。

幸运的是,Picks记得如何修复序列。最初,他应该创建一个整数数组a [1],a [2],…,a [n]。然后,他应该执行一系列m运算。操作可以是以下之一:

打印操作l,r。选择权应记下l-r的和。
模运算l,r,x。选择权应为每个i执行分配a [i] = a [i] mod x(l≤i≤r)。
设置操作k,x。拾取应该将a [k]的值设置为x(换句话说,执行赋值a [k] = x)。
您可以帮助Picks执行整个操作序列吗?

输入值
输入的第一行包含两个整数:n,m(1≤n,m≤105)。第二行包含n个整数,以空格分隔:a [1],a [2],…,a [n](1≤a [i]≤109)—数组元素的初始值。

接下来的m行中的每一行均以数字类型开头。

如果类型= 1,则该行中还会有两个整数:l,r(1≤l≤r≤n),对应于运算1。
如果type = 2,则该行中还会多三个整数:l,r,x(1≤l≤r≤n; 1≤x≤109),对应于运算2。
如果类型= 3,则该行中还会有两个整数:k,x(1≤k≤n; 1≤x≤109),对应于运算3。
输出量
对于每个操作1,请打印包含答案的行。请注意,答案可能超过32位整数。

例子
输入值
5 5
1 2 3 4 5
2 3 5 4
3 3 5
1 2 5
2 1 3 3
1 1 3
输出量
8
5
输入值
10 10
6 9 6 7 6 1 10 10 9 5
1 3 9
2 7 10 9
2 5 10 8
1 4 7
3 3 7
2 7 9 9
1 2 4
1 6 6
1 5 9
3 1 10
输出量
49
15
23
1个
9
注意
考虑第一个测试用例:

首先,a = {1,2,3,4,5}。
在操作1之后,a = {1,2,3,0,1}。
在操作2之后,a = {1,2,5,0,1}。
在操作3中,2 +5 + +0 + 1 + = 8。
在操作4之后,a = {1,2,2,0,1}。
在操作5,1 + 2 + 2 = 5。

题目大意:

输入n和m,表示有n个数和m条命令,接下来的一行输入n个数,表示a[i]-a[n],然后是m行,每行先输入一个命令,再输入相关的值,对于命令有这样三种:

  1. 求区间 a[ l,r ]的和 即a[l]+…+a[r];
  2. 对区间a [ l , r] 的每一个数对x取模,即a[l]mod x … a[r] mod x;
  3. 将a[k]的值改为x。

只有命令1的时候输出sum的值。

解题思路:

这是一道线段树的模板题稍作改变,对于这个题因为有区间每一个数取模,所以我们维护一个最大值,开一个treem数组表示区间最大值。建完树以后,执行取模操作时注意一下剪枝,判断一下该区间的最大值,如果最大值小于x则不执行,因为k%x,只有ak>=x的时候ak的值才会变化,套用线段树模板即可。AC代码(我这里的下标是从0开始的):

#include <cstdio>
#include <iostream>
#include <algorithm>
using namespace std;
using ll = long long;
const ll _max=1e5+50;
ll arr[_max],tree[5*_max],treem[5*_max];
int main()
{
	void build_tree(int,int,int);
	void update(int,int,int,int,int);
	ll query(int,int,int,int,int);
	void mod1(int,int,int,int,int,int);
	int n,m;
	scanf("%d%d",&n,&m);
	for ( int i = 0; i < n; i++)
	  cin>>arr[i];
	build_tree(0,0,n-1);
	while(m--)
	{
		int k,a,b,c;
		scanf("%d",&k);
		if(k==1)
		{
			scanf("%d%d",&a,&b);
			ll sum=query(0,0,n-1,a-1,b-1);
			printf("%lld
",sum);
		}
		else if(k==2)
		{
			scanf("%d%d%d",&a,&b,&c);
			mod1(0,0,n-1,a-1,b-1,c);
		}
		else
		{
			scanf("%d%d",&a,&b);
			update(0,0,n-1,a-1,b);
		}
	}
 	//system("pause");
	return 0;
}
void build_tree(int node ,int start ,int end)
{
	if(start==end)
	{
		tree[node]=arr[start];
		treem[node]=arr[start];
		return;
	}
	int left_node = node*2+1;
	int right_node = node*2+2;
	int mid=(start+end)>>1;
	build_tree(left_node,start,mid);
	build_tree(right_node,mid+1,end);
	tree[node]=tree[left_node]+tree[right_node];
	treem[node]=max(treem[left_node],treem[right_node]);
}
void update(int node, int start, int end, int idx, int val)
{
	if(start==end)
	{
		arr[idx]=val;
		tree[node]=val;
		treem[node]=val;
		return;
	}
	int left_node = node*2+1;
	int right_node = node*2+2;
	int mid=(start+end)>>1;
	if(idx>=start&&idx<=mid)
		update(left_node,start,mid,idx,val);
	else
		update(right_node,mid+1,end,idx,val);
	tree[node]=tree[left_node]+tree[right_node];
	treem[node]=max(treem[left_node],treem[right_node]);
}
ll query(int node, int start, int end, int l, int r)
{
    if(l>end||r<start)
      return 0;
    else if (l<=start&&r>=end)
      return tree[node];
    else if(start==end)
      return tree[node];    
    else 
    {
        int left_node=node*2+1;
        int right_node=node*2+2;
        int mid=(start+end)>>1;
		ll suml,sumr;
		suml=sumr=0;
		if(l<=mid)
          suml=query(left_node,start,mid,l,r);
        if(r>mid)
		  sumr=query(right_node,mid+1,end,l,r);
        return suml+sumr;
    }
}
void mod1(int node, int start, int end, int l, int r,int mod)
{
	if(treem[node]<mod)//剪枝
	  return;
    else if(start==end)
    {
		arr[start]=arr[start]%mod;
		tree[node]=tree[node]%mod;
		treem[node]=treem[node]%mod;
		return;
	}
    else 
    {
        int left_node=node*2+1;
        int right_node=node*2+2;
        int mid=(start+end)>>1;
		if(l<=mid)
          mod1(left_node,start,mid,l,r,mod);
        if(r>mid)
		  mod1(right_node,mid+1,end,l,r,mod);
        tree[node]=tree[left_node]+tree[right_node];
		treem[node]=max(treem[left_node],treem[right_node]);
    }
}
原文地址:https://www.cnblogs.com/Hayasaka/p/14294282.html